package com.izouma.awesomeadmin.web;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.izouma.awesomeadmin.dto.TreeNode;
import com.izouma.awesomeadmin.model.UserInfo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.DepartInfo;
import com.izouma.awesomeadmin.service.DepartInfoService;

import javax.servlet.http.HttpServletRequest;

/**
 * depart_info controller类
 * Thu Apr 26 10:56:37 CST 2018  Suo Chen Cheng
 */
@Controller
@RequestMapping("/departInfo")
public class DepartInfoController {

    @Autowired
    private DepartInfoService departInfoService;

    /**
     * <p>获取全部记录。</p>
     */
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(DepartInfo record) {

        List<DepartInfo> pp = departInfoService.getDepartInfoList(record);
        return new Result(true, pp);
    }

    /**
     * <p>根据Id。</p>
     */
    @RequestMapping(value = "/getDepartInfo", method = RequestMethod.GET)
    @ResponseBody
    public Result getDepartInfo(@RequestParam(required = false, value = "id") String id) {

        DepartInfo data = departInfoService.getDepartInfoById(id);
        return new Result(true, data);
    }

    /**
     * <p>根据条件获取。</p>
     */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(DepartInfo record) {

        DepartInfo data = departInfoService.getDepartInfo(record);
        return new Result(true, data);
    }

    /**
     * <p>分页查询。</p>
     */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, DepartInfo record) {

        Map<String, Object> result = new HashMap<>();

        List<DepartInfo> pp = departInfoService.getDepartInfoByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }

    /**
     * <p>保存。</p>
     */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(HttpServletRequest request, DepartInfo record) {
        boolean num = departInfoService.createDepartInfo(record);
        if (num) {
            return new Result(true, record.getId());
        }
        return new Result(false, "越权操作");
    }

    /**
     * <p>更新信息。</p>
     */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateDepartInfo(HttpServletRequest request, DepartInfo record) {
        boolean num = departInfoService.updateDepartInfo(record);
        if (num) {
            return new Result(true, "保存成功");
        }
        return new Result(false, "越权操作");
    }

    /**
     * <p>删除。</p>
     */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteDepartInfo(HttpServletRequest request, @RequestParam(required = true, value = "id") String id) {
        boolean num = departInfoService.deleteDepartInfo(id);
        if (num) {
            return new Result(true, "删除成功");
        }
        return new Result(false, "越权操作");
    }


    @RequestMapping(value = "/departTree", method = RequestMethod.GET)
    @ResponseBody
    public Result departTree() {
        List<TreeNode> trees = departInfoService.getDepartTree(true, null);
        if (trees != null) {
            return new Result(true, trees);
        }
        return new Result(false, "获取失败");
    }

    @RequestMapping(value = "/departUsers", method = RequestMethod.GET)
    @ResponseBody
    public Result departUsers(@RequestParam("departId") Integer departId) {
        List<UserInfo> users = departInfoService.getDepartUsers(departId);
        if (users != null) {
            return new Result(true, users);
        }
        return new Result(false, "获取失败");
    }

}

